/*
 // SETA43
// http://www.seta43.netau.net/electro.html
//arduino ver 1.0.1  Linux  Debian 7
//18/01/2015
*/


#include <avr/io.h>
#include <avr/interrupt.h>


#define DEBUG 0
#define timebig 0

#define DS1302_SCLK 17    // Arduino pin for the Serial Clock
#define DS1302_IO   18    // Arduino pin for the Data I/O
#define DS1302_CE   19    // Arduino pin for the Chip Enable


#define DS1302_SECONDS           0x80
#define DS1302_MINUTES           0x82
#define DS1302_HOURS             0x84
#define DS1302_DATE              0x86
#define DS1302_MONTH             0x88
#define DS1302_DAY               0x8A
#define DS1302_YEAR              0x8C
#define DS1302_ENABLE            0x8E
#define DS1302_TRICKLE           0x90
#define DS1302_CLOCK_BURST       0xBE
#define DS1302_CLOCK_BURST_WRITE 0xBE
#define DS1302_CLOCK_BURST_READ  0xBF
#define DS1302_RAMSTART          0xC0
#define DS1302_RAMEND            0xFC
#define DS1302_RAM_BURST         0xFE
#define DS1302_RAM_BURST_WRITE   0xFE
#define DS1302_RAM_BURST_READ    0xFF

#define DS1302_D0 0
#define DS1302_D1 1
#define DS1302_D2 2
#define DS1302_D3 3
#define DS1302_D4 4
#define DS1302_D5 5
#define DS1302_D6 6
#define DS1302_D7 7

#define DS1302_READBIT DS1302_D0 // READBIT=1: read instruction
#define DS1302_RC DS1302_D6
#define DS1302_CH DS1302_D7   // 1 = Clock Halt, 0 = start
#define DS1302_AM_PM DS1302_D5 // 0 = AM, 1 = PM
#define DS1302_12_24 DS1302 D7 // 0 = 24 hour, 1 = 12 hour

#define DS1302_WP DS1302_D7   // 1 = Write Protect, 0 = enabled

#define DS1302_ROUT0 DS1302_D0
#define DS1302_ROUT1 DS1302_D1
#define DS1302_DS0   DS1302_D2
#define DS1302_DS1   DS1302_D2
#define DS1302_TCS0  DS1302_D4
#define DS1302_TCS1  DS1302_D5
#define DS1302_TCS2  DS1302_D6
#define DS1302_TCS3  DS1302_D7


typedef struct ds1302_struct
{
  uint8_t Seconds:4;      // low decimal digit 0-9
  uint8_t Seconds10:3;    // high decimal digit 0-5
  uint8_t CH:1;       // CH = Clock Halt
  
  uint8_t Minutes:4;
  uint8_t Minutes10:3;
  uint8_t reserved1:1;
  
  union
  {
    struct
    {
      uint8_t Hour:4;
      uint8_t Hour10:2;
      uint8_t reserved2:1;
      uint8_t hour_12_24:1; // 0 for 24 hour format
      } h24;
      struct
      {
        uint8_t Hour:4;
        uint8_t Hour10:1;
      uint8_t AM_PM:1;      // 0 for AM, 1 for PM
      uint8_t reserved2:1;
      uint8_t hour_12_24:1; // 1 for 12 hour format
      } h12;
    };
    uint8_t Date:4;
    uint8_t Date10:2;
    uint8_t reserved3:2;

    uint8_t Month:4;
    uint8_t Month10:1;
    uint8_t reserved4:3;

    uint8_t Day:3;
    uint8_t reserved5:5;

    uint8_t Year:4;
    uint8_t Year10:4;

    uint8_t reserved6:7;
  uint8_t WP:1;             // WP = Write Protect
};




 char buffer[80];     // the code uses 70 characters.
 ds1302_struct rtc;
 
 byte horas,minutos,segundos,segundos2,dia,mes;
 int ano;
 byte bandera=1;

 byte e1Pin=2;
 byte e2Pin=3;


char *menu[]={"","TIME","DATE"};
 byte mymenu=0;
//___________________________________________



#define sclk 13  // Don't change
#define mosi 11  // Don't change
#define cs   9
#define dc   8
#define rst  7  // you can also connect this to the Arduino reset
#include <Adafruit_GFX.h>    // Core graphics library
#include <Adafruit_QDTech.h> // Hardware-specific library
#include <SPI.h>

Adafruit_QDTech tft = Adafruit_QDTech(cs, dc, rst);       // Invoke custom library

float sx = 0, sy = 1, mx = 1, my = 0, hx = -1, hy = 0;    // Saved H, M, S x & y multipliers
float sdeg=0, mdeg=0, hdeg=0;
uint16_t osx=64, osy=64, omx=64, omy=64, ohx=64, ohy=64;  // Saved H, M, S x & y coords
uint16_t x0=0, x1=0, y0=0, y1=0;

uint8_t hh, mm, ss;  // Get H, M, S from compile time

void setup(void) 
{

  Serial.begin(9600);
  
  pinMode(e1Pin, INPUT);
  pinMode(e2Pin, INPUT);

  DS1302_write (DS1302_ENABLE, 0);
  DS1302_write (DS1302_TRICKLE, 0x00);

  
  //RESET - DS1312  -pulsar los dos pulsadores mientras arranca el reloj
  if(!digitalRead(e1Pin) && !digitalRead(e2Pin))
  {  

    memset ((char *) &rtc, 0, sizeof(rtc));
    rtc.Seconds = 0;
    rtc.Seconds10 = 0;
  rtc.CH = 0;        // 1 for Clock Halt, 0 to run;
  rtc.Minutes = 0;
  rtc.Minutes10 = 0;
  rtc.h24.Hour = 0;
  rtc.h24.Hour10 = 0;
  rtc.h24.hour_12_24 = 0; // 0 for 24 hour format
  rtc.Date = 1;
  rtc.Date10 = 0;
  rtc.Month = 1;
  rtc.Month10 = 0;
  rtc.Day = 1;
  rtc.Year = 1;
  rtc.Year10 = 1;
  rtc.WP = 0;  
  DS1302_clock_burst_write( (uint8_t *) &rtc);

}


  //Interrupcion cada 0.5 segundos
  cli();
  TCCR1A=0;
  TCCR1B=0;
  OCR1A=7812;
  TCCR1B |= (1<<WGM12);
  TCCR1B |= (1<<CS10);
  TCCR1B |= (1<<CS12);
  TIMSK1=(1<<OCIE1A);
  sei();
  
  tft.init();
  tft.setRotation(0);
  
  PanIni(); 

}

void loop() 
{
  
    if(!digitalRead(e1Pin))
        {         
         mymenu++;       
         if(mymenu>2)
             {
               mymenu=0; 
               PanIni();        
             }
           else
             {
               tft.setCursor (1, 20); tft.print(menu[mymenu]);
             }
         while(!digitalRead(e1Pin));
         delay(200);
        }
        
    
    switch(mymenu)
    {    
      
      case 1: 
         sprintf(buffer,"%02d:%02d",horas,minutos);
         tft.setCursor (1, 30); tft.print(buffer);         
          
          if(!digitalRead(e2Pin))
             {  
              while(!digitalRead(e2Pin));            
              menuTime();
              mymenu=0;          
              PanIni();              
             }             
      break;
      
       case 2:
          sprintf(buffer, "%d-%d-%d  ",dia,mes,ano);          
          tft.setCursor (1, 30); tft.print(buffer);    
          if(!digitalRead(e2Pin))
             {  
              while(!digitalRead(e2Pin));            
              menuDate();
              mymenu=0;
              PanIni();
             }       
      break;    
      
    }      
  
  if (bandera==1) 
  {

    bandera=0;
    printReloj();
    
  }
}

static uint8_t conv2d(const char* p) {
  uint8_t v = 0;
  if ('0' <= *p && *p <= '9')
  v = *p - '0';
  return 10 * v + *++p - '0';
}


//------------------------------------------
void menuDate()
{
 byte d1,d,m1,m,a1,a;
   cli();
   while(1)
    {
     tft.setCursor(1,3);
     tft.print("Day     ");
     sprintf(buffer,"%02d  ",dia);
     tft.print(buffer);
      
     if(!digitalRead(e2Pin))
             {
              dia++;
              if(dia>31)dia=1; 
              while(!digitalRead(e2Pin));
             }
     if(!digitalRead(e1Pin))
            {
              while(!digitalRead(e1Pin));
              break;         
            }  
    }
   while(1)
    {
     tft.setCursor(1,3);
     tft.print("Month   ");
     sprintf(buffer,"%02d  ",mes);
     tft.print(buffer);
     
     if(!digitalRead(e2Pin))
             {
              mes++;
              if(mes>12)mes=1; 
              while(!digitalRead(e2Pin));
             }
     if(!digitalRead(e1Pin))
            {
              while(!digitalRead(e1Pin));
              break;         
            }  
    }
   ano-=2000; 
   while(1)
    {
     tft.setCursor(1,3);
     tft.print("Year   ");
     sprintf(buffer,"%d",ano+2000);
     tft.print(buffer);
     
     if(!digitalRead(e2Pin))
             {
              ano++;
              if(ano>50)ano=00; 
              while(!digitalRead(e2Pin));
             }
     if(!digitalRead(e1Pin))
            {
              while(!digitalRead(e1Pin));
              break;         
            }  
    }
  d1=dia/10; d=dia-(d1*10);
  d1=d1<<4; d1=d1 | d;
  DS1302_write(0x86,d1);
  
  m1=mes/10; m=mes-(m1*10);
  m1=m1<<4; m1=m1 | m;
  DS1302_write(0x88,m1);
  
  a1=ano/10; a=ano-(a1*10);
  a1=a1<<4; a1=a1 | a;
  DS1302_write(0x8c,a1);
  sei();
}

//------------------------------------------

void menuTime()
{
  byte h1,h,m1,m;
  cli();
  while(1)
    {
     tft.setCursor(1,3);
     tft.print("Hours   ");
     sprintf(buffer,"%02d  ",horas);
     tft.print(buffer);
     if(!digitalRead(e2Pin))
             {
              horas++;
              if(horas>23)horas=0; 
              while(!digitalRead(e2Pin));
             }
     if(!digitalRead(e1Pin))
            {
              while(!digitalRead(e1Pin));
              break;         
            }  
    }
  while(1)
    {
      tft.setCursor(1,3);
      tft.print("Minutes ");
      sprintf(buffer,"%02d  ",minutos);
      tft.print(buffer);         
      if(!digitalRead(e2Pin))
             {
              minutos++;
              segundos=0;
              if(minutos>59)minutos=0;
              while(!digitalRead(e2Pin));
             }
      if(!digitalRead(e1Pin))
            {
              while(!digitalRead(e1Pin));
              break;         
            }  
    }    
  h1=horas/10; h=horas-(h1*10);
  h1=h1<<4; h1=h1 | h;
  DS1302_write(0x84,h1);
  
  m1=minutos/10; m=minutos-(m1*10);
  m1=m1<<4; m1=m1 | m;
  DS1302_write(0x82,m1);
  
  DS1302_write(0x80,0); //Clear segundos
  
  sei();  
}


void PanIni()
{
  tft.fillScreen(QDTech_BLACK);
  tft.setTextColor(QDTech_WHITE, QDTech_BLACK);  // Adding a black background colour erases previous text automatically
  
  // Draw clock face
  tft.fillCircle(64, 64, 61, QDTech_BLUE);
  tft.fillCircle(64, 64, 57, QDTech_BLACK);

  // Draw 12 lines
  for(int i = 0; i<360; i+= 30) {
    sx = cos((i-90)*0.0174532925);
    sy = sin((i-90)*0.0174532925);
    x0 = sx*57+64;
    y0 = sy*57+64;
    x1 = sx*50+64;
    y1 = sy*50+64;
    
    tft.drawLine(x0, y0, x1, y1, QDTech_BLUE);
  }
  tft.fillCircle(65, 65, 3, QDTech_RED);
  
}

void printReloj()
{
  // Pre-compute hand degrees, x & y coords for a fast screen update

    sdeg = ss*6;                  // 0-59 -> 0-354
    mdeg = mm*6+sdeg*0.01666667;  // 0-59 -> 0-360 - includes seconds
    hdeg = hh*30+mdeg*0.0833333;  // 0-11 -> 0-360 - includes minutes and seconds
    hx = cos((hdeg-90)*0.0174532925);    hy = sin((hdeg-90)*0.0174532925);
    mx = cos((mdeg-90)*0.0174532925);    my = sin((mdeg-90)*0.0174532925);
    sx = cos((sdeg-90)*0.0174532925);    sy = sin((sdeg-90)*0.0174532925);

    // Erase just old hand positions
    tft.drawLine(ohx, ohy, 65, 65, QDTech_BLACK);  
    tft.drawLine(omx, omy, 65, 65, QDTech_BLACK);  
    tft.drawLine(osx, osy, 65, 65, QDTech_BLACK);
    // Draw new hand positions  
    tft.drawLine(hx*33+65, hy*33+65, 65, 65, QDTech_WHITE);
    tft.drawLine(mx*44+65, my*44+65, 65, 65, QDTech_WHITE);
    tft.drawLine(sx*47+65, sy*47+65, 65, 65, QDTech_RED);
    tft.fillCircle(65, 65, 3, QDTech_RED);

    // Update old x&y coords
    osx = sx*47+65;    osy = sy*47+65;
    omx = mx*44+65;    omy = my*44+65;
    ohx = hx*33+65;    ohy = hy*33+65;

    // Update digital time
    tft.setCursor (34, 140); sprintf(buffer,"%02d:%02d:%02d",horas,minutos,segundos);tft.print(buffer);
      tft.setCursor (4, 130); tft.print("xsetaseta@gmail.com");
      sprintf(buffer, "%02d-%02d-%04d",dia,mes,ano);
      tft.setCursor (34, 151); tft.print(buffer);  
    }



    ISR(TIMER1_COMPA_vect)
    {
   // Read all clock data at once (burst mode).
   DS1302_clock_burst_read( (uint8_t *) &rtc);
   #if DEBUG 
   Serial.println("0.2");
   #endif
   segundos2=(rtc.Seconds10 * 10) + rtc.Seconds;
   if(segundos!=segundos2)
   {
     bandera=1;
     ss=segundos=segundos2;
     mm=minutos=(rtc.Minutes10 * 10) + rtc.Minutes;
     hh=horas=(rtc.h24.Hour10 * 10) + rtc.h24.Hour;
     dia=(rtc.Date10 * 10) + rtc.Date;
     mes=(rtc.Month10 * 10) + rtc.Month;
     ano=2000+(rtc.Year10 * 10) + rtc.Year;
     
     #if DEBUG 
     sprintf(buffer,"%02d:%02d:%02d",horas,minutos,segundos); Serial.println(buffer);
     sprintf(buffer, "%02d-%02d-%04d",dia,mes,ano); Serial.println(buffer);
     #endif  
   }
 }



//--------------------------------------

void DS1302_clock_burst_read( uint8_t *p)
{
  int i;

  _DS1302_start();
  _DS1302_togglewrite( DS1302_CLOCK_BURST_READ, true);  
  for (i=0; i<8; i++)    *p++ = _DS1302_toggleread();  
  _DS1302_stop();
}


void DS1302_clock_burst_write( uint8_t *p)
{
  int i;

  _DS1302_start();
  _DS1302_togglewrite( DS1302_CLOCK_BURST_WRITE, false);  
  for (i=0; i<8; i++)    _DS1302_togglewrite( *p++, false);  
  _DS1302_stop();
}

uint8_t DS1302_read(int address)
{
  uint8_t data;

  bitSet (address, DS1302_READBIT);  
  _DS1302_start();
  _DS1302_togglewrite (address, true);  
  data = _DS1302_toggleread ();
  _DS1302_stop();

  return (data);
}

void DS1302_write(int address, uint8_t data)
{
  bitClear (address, DS1302_READBIT);  

  _DS1302_start();
  _DS1302_togglewrite (address, false);
  _DS1302_togglewrite (data, false);
  _DS1302_stop();  
}

void _DS1302_start(void)
{
  digitalWrite (DS1302_CE, LOW); // default, not enabled
  pinMode (DS1302_CE, OUTPUT);  
  digitalWrite (DS1302_SCLK, LOW); // default, clock low
  pinMode (DS1302_SCLK, OUTPUT);
  pinMode (DS1302_IO, OUTPUT);
  digitalWrite (DS1302_CE, HIGH); // start the session
  delayMicroseconds(4);           // tCC = 4us
}

void _DS1302_stop(void)
{
  digitalWrite (DS1302_CE, LOW);
  delayMicroseconds(4);           // tCWH = 4us
}


uint8_t _DS1302_toggleread(void)
{
  uint8_t i, data;

  data = 0;
  for (i = 0; i <= 7; i++)
  {
    digitalWrite (DS1302_SCLK, HIGH);
    delayMicroseconds(1);
    digitalWrite (DS1302_SCLK, LOW);
    delayMicroseconds(1);        // tCL=1000ns, tCDD=800ns
    bitWrite (data, i, digitalRead(DS1302_IO));
  }
  return (data);
}


void _DS1302_togglewrite(uint8_t data, uint8_t release)
{
  int i;

  for (i = 0; i <= 7; i++)
  {
    digitalWrite (DS1302_IO, bitRead(data, i));  
    delayMicroseconds(1);     // tDC = 200ns
    digitalWrite (DS1302_SCLK, HIGH);    
    delayMicroseconds(1);     // tCH = 1000ns, tCDH = 800ns
    if (release && i == 7)
    {
      pinMode (DS1302_IO, INPUT);
      digitalWrite (DS1302_IO, LOW); // remove any pull-up  
    }
    else
    {
      digitalWrite (DS1302_SCLK, LOW);
      delayMicroseconds(1);       // tCL=1000ns, tCDD=800ns
    }
  }
}


